/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved    */

#include "cbtree.h"

#if EC | DC
void  relstack();
#endif

#define MAXSTACK 20          /* maximum depth of stack   */

int sp = 0;           /* stack pointer         */
long val[MAXSTACK];          /* value stack         */

/*---------------------------------------------------------------------------- 
 * pushdown() is used to keep track of the index nodes at each level as 
 * the B+tree is searched.  As each level is descended, the node at the 
 * current level is pushed onto the stack.
 *---------------------------------------------------------------------------*/
long pushdown(sv)     /* push sv onto stack     */
long sv;
{

   if(sp < MAXSTACK)
      return(val[sp++] = sv);
   puts("pushdown() error: stackop full... ");
   relstack();
   ckerror( CK_STAK, "39");
   return(0L);
}

/*---------------------------------------------------------------------------- 
 * poptop() - (like pushdown) keeps track of the index nodes at each level 
 * as the B+tree is searched.  To return to the previous level upwards 
 * poptop() is called to return the pointer value to the previous node.
 *---------------------------------------------------------------------------*/
long poptop()          /* pop top from stack    */
{
   if(sp > 0)
      return(val[--sp]);
   relstack();
   return(0L);
}

/*---------------------------------------------------------------------------- 
 * relstack() is called to clear the stack when the stack is no longer needed.
 *---------------------------------------------------------------------------*/
void relstack()               /* clear stack        */
{
   sp = 0;
}
